/** generated file, do not edit! */
#ifndef DT_PREFERENCES_H
#define DT_PREFERENCES_H

#pragma GCC diagnostic ignored "-Wunused-function"
#pragma GCC diagnostic ignored "-Wunused-variable"

#include <gtk/gtk.h>
#include "control/conf.h"
#include "common/calculator.h"

#define NON_DEF_CHAR "●"

static gboolean handle_enter_key(GtkWidget *widget, GdkEvent *event, gpointer data)
{
  guint keyval;

  gdk_event_get_keyval ((GdkEvent*)event, &keyval);

  if (keyval == GDK_KEY_Return || keyval == GDK_KEY_KP_Enter)
     return TRUE;
  return FALSE;
}

static void set_widget_label_default(GtkWidget *widget, const char *confstr, GtkWidget *label, const float factor)
{
  gboolean is_default = TRUE;

  if (GTK_IS_CHECK_BUTTON(widget))
  {
    const gboolean c_default = dt_confgen_get_bool(confstr, DT_DEFAULT);
    const gboolean c_state = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget));
    is_default = (c_state == c_default);
  }
  else if(GTK_IS_COMBO_BOX(widget))
  {
    const gchar *c_default = dt_confgen_get(confstr, DT_DEFAULT);
    GtkTreeIter iter;
    GtkTreeModel *model = gtk_combo_box_get_model(GTK_COMBO_BOX(widget));
    const gint active = gtk_combo_box_get_active(GTK_COMBO_BOX(widget));
    gchar *c_state = NULL;
    gtk_tree_model_iter_nth_child(model, &iter, NULL, active);
    gtk_tree_model_get(model, &iter, 0, &c_state, -1);
    is_default = (g_strcmp0(c_state, c_default) == 0);
  }
  else if(GTK_IS_SPIN_BUTTON(widget))
  {
    const gchar *c_default = dt_confgen_get(confstr, DT_DEFAULT);
    const float v_default = dt_calculator_solve(1, c_default) * factor;
    const float v_state = gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget));
    is_default = (v_state == v_default);
  }
  else if(GTK_IS_ENTRY(widget))
  {
    const gchar *c_default = dt_confgen_get(confstr, DT_DEFAULT);
    const gchar *c_state = gtk_entry_get_text(GTK_ENTRY(widget));
    is_default = (g_strcmp0(c_state, c_default) == 0);
  }
  else if(GTK_IS_FILE_CHOOSER(widget))
  {
    const gchar *c_default = dt_confgen_get(confstr, DT_DEFAULT);
    const gchar *c_state = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(widget));
    is_default = (g_strcmp0(c_state, c_default) == 0);
  }
  else
  {
    // other unsupported widgets
    return;
  }

  if(is_default)
  {
    // replace * with space
    gtk_label_set_text(GTK_LABEL(label), "");
    g_object_set(label, "tooltip-text", NULL, (gchar *)0);
  }
  else
  {
    // replace space with *
    gtk_label_set_text(GTK_LABEL(label), NON_DEF_CHAR);
    g_object_set(label, "tooltip-text", _("this setting has been modified"), (gchar *)0);
  }
}

gboolean restart_required = FALSE;
static gboolean
reset_widget_idm139701110183952 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110180832 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110177616 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110174512 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110171408 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110167040 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110159264 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110153712 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110146288 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 2);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110112560 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 25 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110109616 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 2);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110104176 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 10 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110091200 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 5 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110086160 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110080432 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110077328 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110074336 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110057856 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 2);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110052992 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 2);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110048432 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110045440 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110042672 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110038624 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110035248 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110030032 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110017584 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110014496 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110011440 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110008368 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110005280 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701110002208 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109999136 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109996032 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 10 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109992688 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109989824 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 10 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109986592 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109937104 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 1 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109903088 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109899184 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109701280 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 8);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109693888 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 3);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109686864 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_entry_set_text(GTK_ENTRY(widget), "120|400");
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109683616 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {

        gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)), "$(FILE_NAME).$(FILE_EXTENSION)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH)mm • $(EXIF_ISO) ISO $(SIDECAR_TXT)", strlen("$(FILE_NAME).$(FILE_EXTENSION)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH)mm • $(EXIF_ISO) ISO $(SIDECAR_TXT)"));
     
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109680272 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {

        gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)), "<b>$(FILE_NAME).$(FILE_EXTENSION)</b>$(NL)$(EXIF_DAY)/$(EXIF_MONTH)/$(EXIF_YEAR) $(EXIF_HOUR):$(EXIF_MINUTE):$(EXIF_SECOND)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO", strlen("<b>$(FILE_NAME).$(FILE_EXTENSION)</b>$(NL)$(EXIF_DAY)/$(EXIF_MONTH)/$(EXIF_YEAR) $(EXIF_HOUR):$(EXIF_MINUTE):$(EXIF_SECOND)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO"));
     
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109676832 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109670816 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109666096 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109662864 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109658576 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {

        gtk_text_buffer_set_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget)), "$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO", strlen("$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO"));
     
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109655344 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 3);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109644976 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109641872 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109638752 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109635696 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109632592 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_entry_set_text(GTK_ENTRY(widget), "$(PICTURES_FOLDER)/Darktable");
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109629504 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_entry_set_text(GTK_ENTRY(widget), "$(YEAR)$(MONTH)$(DAY)_$(JOBCODE)");
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109626416 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109623344 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_entry_set_text(GTK_ENTRY(widget), "$(YEAR)$(MONTH)$(DAY)_$(SEQUENCE).$(FILE_EXTENSION)");
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109581600 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109509696 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109490064 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 50 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109486912 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 20 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109464080 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109461184 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109458080 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109430320 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109427200 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109421504 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109418400 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109415248 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109410048 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109383600 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109380464 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109377280 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    float factor = 1.0f;
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), 10 * factor);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109374224 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109371168 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109357264 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109351696 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109348576 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109345504 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109320496 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109315504 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109310416 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109307280 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109302512 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 3);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109200640 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109119168 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109028240 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109020752 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109017680 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_entry_set_text(GTK_ENTRY(widget), "aplay");
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109014560 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gchar *path = dt_conf_expand_default_dir("$(home)");
    dt_conf_set_string("plugins/darkroom/lut3d/def_path", path);
    g_free(path);
    path = dt_conf_get_string("plugins/darkroom/lut3d/def_path");
    gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(widget), path);
    g_free(path);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109011216 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109006384 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 1);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701109001952 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108998288 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108995088 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108991952 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108952608 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108932144 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108927248 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), 0);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108920080 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), TRUE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108916960 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), FALSE);
    return TRUE;
  }
  return FALSE;
}

static gboolean
reset_widget_idm139701108844128 (GtkWidget *label, GdkEventButton *event, GtkWidget *widget)
{
  if(event->type == GDK_2BUTTON_PRESS)
  {
    gtk_entry_set_text(GTK_ENTRY(widget), "");
    return TRUE;
  }
  return FALSE;
}

static void
preferences_response_callback_idm139701110183952 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("accel/prefer_focused", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110180832 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("accel/prefer_expanded", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110177616 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("accel/prefer_enabled", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110174512 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("accel/prefer_unmasked", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110171408 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("accel/select_order", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110167040 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("accel/assign_instance", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110159264 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("accel/load_defaults", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110153712 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("bauhaus/zoom_step", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110146288 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("database/maintenance_check", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110112560 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("database/maintenance_freepage_ratio", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701110109616 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("database/create_snapshot", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110104176 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("database/keep_snapshots", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701110091200 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("slideshow_delay", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701110086160 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("resourcelevel", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110080432 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ui/performance", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110077328 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("cache_disk_backend", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110074336 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("cache_disk_backend_full", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110057856 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("write_sidecar_files", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110052992 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("compress_xmp_tags", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110048432 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("omit_tag_hierarchy", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110045440 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/tagging/no_uncategorized", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110042672 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/lighttable/tagging/case_sensitivity", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110038624 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("opencl", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110035248 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("opencl_scheduling_profile", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110030032 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("opencl_tuning_mode", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701110017584 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ask_before_remove", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110014496 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ask_before_delete", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110011440 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ask_before_discard", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110008368 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("send_to_trash", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110005280 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ask_before_move", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701110002208 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ask_before_copy", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109999136 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ask_before_rmdir", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109996032 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("plugins/lighttable/recentcollect/max_items", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701109992688 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/recentcollect/hide", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109989824 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("plugins/lighttable/collect/history_max", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701109986592 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/collect/history_hide", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109937104 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("show_folder_levels", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701109903088 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/collect/filmroll_sort", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109899184 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/collect/descending", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109701280 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/lighttable/thumbnail_raw_min_level", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109693888 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/lighttable/thumbnail_hq_min_level", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109686864 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_string("plugins/lighttable/thumbnail_sizes", gtk_entry_get_text(GTK_ENTRY(widget)));
}

static void
preferences_response_callback_idm139701109683616 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));

        GtkTextIter start, end;
        GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));
        gtk_text_buffer_get_start_iter(buffer, &start);
        gtk_text_buffer_get_end_iter(buffer, &end);
        dt_conf_set_string("plugins/lighttable/extended_pattern", gtk_text_buffer_get_text(buffer, &start, &end, FALSE));
     
}

static void
preferences_response_callback_idm139701109680272 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));

        GtkTextIter start, end;
        GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));
        gtk_text_buffer_get_start_iter(buffer, &start);
        gtk_text_buffer_get_end_iter(buffer, &end);
        dt_conf_set_string("plugins/lighttable/thumbnail_tooltip_pattern", gtk_text_buffer_get_text(buffer, &start, &end, FALSE));
     
}

static void
preferences_response_callback_idm139701109676832 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("pressure_sensitivity", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109670816 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("brush_smoothing", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109666096 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("masks_scroll_down_increases", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109662864 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("channel_display", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109658576 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));

        GtkTextIter start, end;
        GtkTextBuffer *buffer = gtk_text_view_get_buffer(GTK_TEXT_VIEW(widget));
        gtk_text_buffer_get_start_iter(buffer, &start);
        gtk_text_buffer_get_end_iter(buffer, &end);
        dt_conf_set_string("plugins/darkroom/image_infos_pattern", gtk_text_buffer_get_text(buffer, &start, &end, FALSE));
     
}

static void
preferences_response_callback_idm139701109655344 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/image_infos_position", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109644976 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("modules/default_presets_first", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109641872 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/darkroom/hide_default_presets", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109638752 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/darkroom/show_guides_in_ui", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109635696 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/hide_default_presets", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109632592 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_string("session/base_directory_pattern", gtk_entry_get_text(GTK_ENTRY(widget)));
}

static void
preferences_response_callback_idm139701109629504 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_string("session/sub_directory_pattern", gtk_entry_get_text(GTK_ENTRY(widget)));
}

static void
preferences_response_callback_idm139701109626416 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("session/use_filename", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109623344 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_string("session/filename_pattern", gtk_entry_get_text(GTK_ENTRY(widget)));
}

static void
preferences_response_callback_idm139701109581600 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/collect/single-click", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109509696 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/tagging/ask_before_delete_tag", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109490064 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("plugins/lighttable/tagging/confidence", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701109486912 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("plugins/lighttable/tagging/nb_recent_tags", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701109464080 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/style/ask_before_delete_style", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109461184 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/preset/ask_before_delete_preset", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109458080 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/export/ask_before_export_overwrite", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109430320 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/metadata_view/pretty_location", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109427200 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("lighttable/ui/single_module", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109421504 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/single_module", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109418400 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/single_module_group_only", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109415248 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/activate_expand", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109410048 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("lighttable/ui/scroll_to_module", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109383600 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/scroll_to_module", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109380464 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/sidebar_scroll_default", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109377280 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  float factor = 1.0f;
  dt_conf_set_int("plugins/darkroom/ui/border_size", gtk_spin_button_get_value(GTK_SPIN_BUTTON(widget)) / factor);
}

static void
preferences_response_callback_idm139701109374224 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/scrollbars", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109371168 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("panel_scrollbars_always_visible", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109357264 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/lighttable/export/force_lcms2", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109351696 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("rating_one_double_tap", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109348576 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("lighttable/ui/scrollbars", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109345504 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("lighttable/ui/milliseconds", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109320496 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/demosaic/quality", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109315504 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("preview_downsampling", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109310416 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/loading_screen", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109307280 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/lighttable/export/pixel_interpolator_warp", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109302512 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/lighttable/export/pixel_interpolator", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109200640 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/pwstorage/pwstorage_backend", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109119168 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/histogram/panel_position", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109028240 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("ui_last/display_profile_source", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109020752 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("run_crawler_on_start", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701109017680 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_string("plugins/lighttable/audio_player", gtk_entry_get_text(GTK_ENTRY(widget)));
}

static void
preferences_response_callback_idm139701109014560 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  gchar *folder = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(widget));
  dt_conf_set_string("plugins/darkroom/lut3d/def_path", folder);
  g_free(folder);
}

static void
preferences_response_callback_idm139701109011216 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/workflow", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109006384 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/chromatic-adaptation", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701109001952 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/darkroom/basecurve/auto_apply_percamera_presets", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701108998288 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/darkroom/sharpen/auto_apply", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701108995088 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("ui/detect_mono_exif", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701108991952 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("plugins/darkroom/show_warnings", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701108952608 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/temperature/colored_sliders", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701108932144 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("plugins/darkroom/colorbalance/layout", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701108927248 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  GtkTreeIter iter;
  if(gtk_combo_box_get_active_iter(GTK_COMBO_BOX(widget), &iter))
  {
    gchar *s = NULL;
    gtk_tree_model_get(gtk_combo_box_get_model(GTK_COMBO_BOX(widget)), &iter, 0, &s, -1);
    dt_conf_set_string("darkroom/ui/hide_header_buttons", s);
    g_free(s);
  }
}

static void
preferences_response_callback_idm139701108920080 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/show_mask_indicator", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701108916960 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_bool("darkroom/ui/rename_new_instance", gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)));
}

static void
preferences_response_callback_idm139701108844128 (GtkDialog *dialog, gint response_id, GtkWidget *widget)
{
  const gint dkind = GPOINTER_TO_INT(g_object_get_data(G_OBJECT(dialog), "local-dialog"));
  if(dkind)
  {
    if(response_id == GTK_RESPONSE_NONE) return;
    if(response_id == GTK_RESPONSE_DELETE_EVENT) return;
  }
  else
  {
    if(response_id != GTK_RESPONSE_DELETE_EVENT) return;
  }
  gtk_widget_set_can_focus(GTK_WIDGET(dialog), TRUE);
  gtk_widget_grab_focus(GTK_WIDGET(dialog));
  dt_conf_set_string("plugins/midi/devices", gtk_entry_get_text(GTK_ENTRY(widget)));
}

static void
preferences_changed_callback_idm139701110183952 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/prefer_focused", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110180832 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/prefer_expanded", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110177616 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/prefer_enabled", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110174512 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/prefer_unmasked", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110171408 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/select_order", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110167040 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/assign_instance", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110159264 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "accel/load_defaults", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110153712 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "bauhaus/zoom_step", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110146288 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "database/maintenance_check", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110112560 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "database/maintenance_freepage_ratio", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110109616 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "database/create_snapshot", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110104176 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "database/keep_snapshots", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110091200 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "slideshow_delay", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110086160 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "resourcelevel", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110080432 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ui/performance", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110077328 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "cache_disk_backend", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110074336 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "cache_disk_backend_full", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110057856 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "write_sidecar_files", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110052992 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "compress_xmp_tags", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110048432 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "omit_tag_hierarchy", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110045440 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/tagging/no_uncategorized", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110042672 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/tagging/case_sensitivity", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110038624 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "opencl", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110035248 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "opencl_scheduling_profile", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110030032 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "opencl_tuning_mode", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110017584 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ask_before_remove", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110014496 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ask_before_delete", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110011440 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ask_before_discard", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110008368 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "send_to_trash", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110005280 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ask_before_move", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701110002208 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ask_before_copy", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109999136 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ask_before_rmdir", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109996032 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/recentcollect/max_items", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109992688 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/recentcollect/hide", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109989824 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/collect/history_max", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109986592 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/collect/history_hide", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109937104 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "show_folder_levels", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109903088 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/collect/filmroll_sort", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109899184 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/collect/descending", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109701280 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/thumbnail_raw_min_level", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109693888 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/thumbnail_hq_min_level", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109686864 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/thumbnail_sizes", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109683616 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/extended_pattern", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109680272 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/thumbnail_tooltip_pattern", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109676832 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "pressure_sensitivity", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109670816 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "brush_smoothing", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109666096 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "masks_scroll_down_increases", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109662864 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "channel_display", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109658576 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/image_infos_pattern", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109655344 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/image_infos_position", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109644976 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "modules/default_presets_first", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109641872 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/hide_default_presets", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109638752 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/show_guides_in_ui", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109635696 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/hide_default_presets", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109632592 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "session/base_directory_pattern", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109629504 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "session/sub_directory_pattern", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109626416 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "session/use_filename", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109623344 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "session/filename_pattern", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109581600 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/collect/single-click", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109509696 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/tagging/ask_before_delete_tag", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109490064 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/tagging/confidence", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109486912 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/tagging/nb_recent_tags", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109464080 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/style/ask_before_delete_style", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109461184 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/preset/ask_before_delete_preset", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109458080 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/export/ask_before_export_overwrite", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109430320 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/metadata_view/pretty_location", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109427200 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "lighttable/ui/single_module", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109421504 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/single_module", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109418400 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/single_module_group_only", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109415248 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/activate_expand", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109410048 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "lighttable/ui/scroll_to_module", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109383600 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/scroll_to_module", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109380464 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/sidebar_scroll_default", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109377280 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/ui/border_size", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109374224 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/scrollbars", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109371168 (GtkWidget *widget, gpointer user_data)
{
  restart_required = TRUE;
  float factor = 1.0f;
  set_widget_label_default(widget, "panel_scrollbars_always_visible", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109357264 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/export/force_lcms2", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109351696 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "rating_one_double_tap", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109348576 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "lighttable/ui/scrollbars", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109345504 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "lighttable/ui/milliseconds", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109320496 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/demosaic/quality", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109315504 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "preview_downsampling", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109310416 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/loading_screen", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109307280 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/export/pixel_interpolator_warp", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109302512 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/export/pixel_interpolator", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109200640 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/pwstorage/pwstorage_backend", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109119168 (GtkWidget *widget, gpointer user_data)
{
  restart_required = TRUE;
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/histogram/panel_position", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109028240 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ui_last/display_profile_source", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109020752 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "run_crawler_on_start", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109017680 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/lighttable/audio_player", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109014560 (GtkWidget *widget, gpointer user_data)
{
  restart_required = TRUE;
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/lut3d/def_path", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109011216 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/workflow", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109006384 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/chromatic-adaptation", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701109001952 (GtkWidget *widget, gpointer user_data)
{
  restart_required = TRUE;
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/basecurve/auto_apply_percamera_presets", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108998288 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/sharpen/auto_apply", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108995088 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "ui/detect_mono_exif", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108991952 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/show_warnings", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108952608 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/temperature/colored_sliders", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108932144 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/darkroom/colorbalance/layout", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108927248 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/hide_header_buttons", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108920080 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/show_mask_indicator", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108916960 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "darkroom/ui/rename_new_instance", GTK_WIDGET(user_data), factor);
}

static void
preferences_changed_callback_idm139701108844128 (GtkWidget *widget, gpointer user_data)
{
  float factor = 1.0f;
  set_widget_label_default(widget, "plugins/midi/devices", GTK_WIDGET(user_data), factor);
}


static void
init_tab_lighttable (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("lighttable"), _("lighttable"));

    {
      GtkWidget *seclabel = gtk_label_new(_("general"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
    }
  
  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/hide_default_presets");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("hide built-in presets for utility modules"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/hide_default_presets"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109635696), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109635696), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("hides built-in presets of utility modules in presets menu."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/hide_default_presets");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109635696), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/collect/single-click");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("use single-click in the collections module"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/collect/single-click"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109581600), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109581600), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("check this option to use single-click to select items in the collections module. this will allow you to do range selections for date-time and numeric values."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/collect/single-click");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109581600), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("lighttable/ui/single_module");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("expand a single utility module at a time"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("lighttable/ui/single_module"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109427200), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109427200), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this option toggles the behavior of shift clicking in lighttable mode"), (gchar *)0);
    gtk_widget_set_name(widget, "lighttable/ui/single_module");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109427200), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("lighttable/ui/scroll_to_module");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("scroll utility modules to the top when expanded"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("lighttable/ui/scroll_to_module"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109410048), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109410048), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when this option is enabled then darktable will try to scroll the module to the top of the visible list"), (gchar *)0);
    gtk_widget_set_name(widget, "lighttable/ui/scroll_to_module");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109410048), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("rating_one_double_tap");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("rating an image one star twice will not zero out the rating"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("rating_one_double_tap"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109351696), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109351696), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines whether rating an image one star twice will zero out star rating"), (gchar *)0);
    gtk_widget_set_name(widget, "rating_one_double_tap");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109351696), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("lighttable/ui/scrollbars");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show scrollbars for central view"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("lighttable/ui/scrollbars"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109348576), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109348576), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines whether scrollbars should be displayed"), (gchar *)0);
    gtk_widget_set_name(widget, "lighttable/ui/scrollbars");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109348576), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("lighttable/ui/milliseconds");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show image time with milliseconds"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("lighttable/ui/milliseconds"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109345504), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109345504), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines whether time should be displayed with milliseconds"), (gchar *)0);
    gtk_widget_set_name(widget, "lighttable/ui/milliseconds");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109345504), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("thumbnails"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }
  
  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/thumbnail_raw_min_level");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("use raw file instead of embedded JPEG from size"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/lighttable/thumbnail_raw_min_level");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "always", 1, C_("preferences", "always"), -1);
        if(pos == -1 && strcmp(str, "always") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "small", 1, C_("preferences", "small"), -1);
        if(pos == -1 && strcmp(str, "small") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "VGA", 1, C_("preferences", "VGA"), -1);
        if(pos == -1 && strcmp(str, "VGA") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "720p", 1, C_("preferences", "720p"), -1);
        if(pos == -1 && strcmp(str, "720p") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "1080p", 1, C_("preferences", "1080p"), -1);
        if(pos == -1 && strcmp(str, "1080p") == 0)
          pos = 4;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "WQXGA", 1, C_("preferences", "WQXGA"), -1);
        if(pos == -1 && strcmp(str, "WQXGA") == 0)
          pos = 5;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "4K", 1, C_("preferences", "4K"), -1);
        if(pos == -1 && strcmp(str, "4K") == 0)
          pos = 6;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "5K", 1, C_("preferences", "5K"), -1);
        if(pos == -1 && strcmp(str, "5K") == 0)
          pos = 7;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "never", 1, C_("preferences", "never"), -1);
        if(pos == -1 && strcmp(str, "never") == 0)
          pos = 8;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109701280), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109701280), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "never"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if the thumbnail size is greater than this value, it will be processed using raw file instead of the embedded preview JPEG (better but slower).\nif you want all thumbnails and pre-rendered images in best quality you should choose the *always* option.\n(more comments in the manual)"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/thumbnail_raw_min_level");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109701280), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/thumbnail_hq_min_level");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("high quality processing from size"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/lighttable/thumbnail_hq_min_level");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "always", 1, C_("preferences", "always"), -1);
        if(pos == -1 && strcmp(str, "always") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "small", 1, C_("preferences", "small"), -1);
        if(pos == -1 && strcmp(str, "small") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "VGA", 1, C_("preferences", "VGA"), -1);
        if(pos == -1 && strcmp(str, "VGA") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "720p", 1, C_("preferences", "720p"), -1);
        if(pos == -1 && strcmp(str, "720p") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "1080p", 1, C_("preferences", "1080p"), -1);
        if(pos == -1 && strcmp(str, "1080p") == 0)
          pos = 4;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "WQXGA", 1, C_("preferences", "WQXGA"), -1);
        if(pos == -1 && strcmp(str, "WQXGA") == 0)
          pos = 5;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "4K", 1, C_("preferences", "4K"), -1);
        if(pos == -1 && strcmp(str, "4K") == 0)
          pos = 6;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "5K", 1, C_("preferences", "5K"), -1);
        if(pos == -1 && strcmp(str, "5K") == 0)
          pos = 7;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "never", 1, C_("preferences", "never"), -1);
        if(pos == -1 && strcmp(str, "never") == 0)
          pos = 8;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109693888), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109693888), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "720p"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if the thumbnail size is greater than this value, it will be processed using the full quality rendering path (better but slower).\nif you want all thumbnails and pre-rendered images in best quality you should choose the *always* option.\n(more comments in the manual)"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/thumbnail_hq_min_level");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109693888), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/thumbnail_sizes");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("delimiters for size categories"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_entry_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/lighttable/thumbnail_sizes");
    gtk_entry_set_text(GTK_ENTRY(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109686864), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109686864), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "120|400");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("size categories are used to be able to set different overlays and css values depending of the size of the thumbnail, separated by |. for example, 120|400 means 3 categories of thumbnails: 0px->120px, 120px->400px and >400px"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/thumbnail_sizes");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109686864), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/extended_pattern");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pattern for the thumbnail extended overlay text"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTextBuffer *buffer = gtk_text_buffer_new(NULL);
    widget = gtk_text_view_new_with_buffer(buffer);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(widget), GTK_WRAP_WORD);
    gtk_text_view_set_accepts_tab(GTK_TEXT_VIEW(widget), FALSE);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/lighttable/extended_pattern");
    gtk_text_buffer_set_text(buffer, setting, strlen(setting));
    g_free(setting);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109683616), widget);
    g_signal_connect(G_OBJECT(widget), "key-press-event", G_CALLBACK(handle_enter_key), NULL);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "$(FILE_NAME).$(FILE_EXTENSION)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH)mm • $(EXIF_ISO) ISO $(SIDECAR_TXT)");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("see manual to know all the tags you can use."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/extended_pattern");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109683616), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/thumbnail_tooltip_pattern");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pattern for the thumbnail tooltip (empty to disable)"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTextBuffer *buffer = gtk_text_buffer_new(NULL);
    widget = gtk_text_view_new_with_buffer(buffer);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(widget), GTK_WRAP_WORD);
    gtk_text_view_set_accepts_tab(GTK_TEXT_VIEW(widget), FALSE);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/lighttable/thumbnail_tooltip_pattern");
    gtk_text_buffer_set_text(buffer, setting, strlen(setting));
    g_free(setting);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109680272), widget);
    g_signal_connect(G_OBJECT(widget), "key-press-event", G_CALLBACK(handle_enter_key), NULL);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "<b>$(FILE_NAME).$(FILE_EXTENSION)</b>$(NL)$(EXIF_DAY)/$(EXIF_MONTH)/$(EXIF_YEAR) $(EXIF_HOUR):$(EXIF_MINUTE):$(EXIF_SECOND)$(NL)$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("see manual to know all the tags you can use."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/thumbnail_tooltip_pattern");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109680272), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

static void
init_tab_darkroom (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("darkroom"), _("darkroom"));

    {
      GtkWidget *seclabel = gtk_label_new(_("general"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
    }
  
  {
    const gboolean is_default = dt_conf_is_default("pressure_sensitivity");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pen pressure control for brush masks"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("pressure_sensitivity");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "off", 1, C_("preferences", "off"), -1);
        if(pos == -1 && strcmp(str, "off") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "hardness (relative)", 1, C_("preferences", "hardness (relative)"), -1);
        if(pos == -1 && strcmp(str, "hardness (relative)") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "hardness (absolute)", 1, C_("preferences", "hardness (absolute)"), -1);
        if(pos == -1 && strcmp(str, "hardness (absolute)") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "opacity (relative)", 1, C_("preferences", "opacity (relative)"), -1);
        if(pos == -1 && strcmp(str, "opacity (relative)") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "opacity (absolute)", 1, C_("preferences", "opacity (absolute)"), -1);
        if(pos == -1 && strcmp(str, "opacity (absolute)") == 0)
          pos = 4;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "brush size (relative)", 1, C_("preferences", "brush size (relative)"), -1);
        if(pos == -1 && strcmp(str, "brush size (relative)") == 0)
          pos = 5;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109676832), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109676832), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "off"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("off - pressure reading ignored, hardness/opacity/brush size - pressure reading controls specified attribute, absolute/relative - pressure reading is taken directly as attribute value or multiplied with pre-defined setting."), (gchar *)0);
    gtk_widget_set_name(widget, "pressure_sensitivity");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109676832), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("brush_smoothing");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("smoothing of brush strokes"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("brush_smoothing");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "low", 1, C_("preferences", "low"), -1);
        if(pos == -1 && strcmp(str, "low") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "medium", 1, C_("preferences", "medium"), -1);
        if(pos == -1 && strcmp(str, "medium") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "high", 1, C_("preferences", "high"), -1);
        if(pos == -1 && strcmp(str, "high") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109670816), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109670816), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "medium"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("sets level for smoothing of brush strokes. stronger smoothing leads to less nodes and easier editing but with lower control of accuracy."), (gchar *)0);
    gtk_widget_set_name(widget, "brush_smoothing");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109670816), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("masks_scroll_down_increases");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("scroll down to increase mask parameters"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("masks_scroll_down_increases"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109666096), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109666096), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when using the mouse scroll wheel to change mask parameters, scroll down to increase the mask size, feather size, opacity, brush hardness and gradient curvature\nby default scrolling up increases these parameters"), (gchar *)0);
    gtk_widget_set_name(widget, "masks_scroll_down_increases");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109666096), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/image_infos_pattern");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pattern for the image information line"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTextBuffer *buffer = gtk_text_buffer_new(NULL);
    widget = gtk_text_view_new_with_buffer(buffer);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(widget), GTK_WRAP_WORD);
    gtk_text_view_set_accepts_tab(GTK_TEXT_VIEW(widget), FALSE);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/darkroom/image_infos_pattern");
    gtk_text_buffer_set_text(buffer, setting, strlen(setting));
    g_free(setting);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109658576), widget);
    g_signal_connect(G_OBJECT(widget), "key-press-event", G_CALLBACK(handle_enter_key), NULL);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "$(EXIF_EXPOSURE) • f/$(EXIF_APERTURE) • $(EXIF_FOCAL_LENGTH) mm • $(EXIF_ISO) ISO");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("see manual for a list of the tags you can use."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/image_infos_pattern");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109658576), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/image_infos_position");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("position of the image information line"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/image_infos_position");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "top left", 1, C_("preferences", "top left"), -1);
        if(pos == -1 && strcmp(str, "top left") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "top right", 1, C_("preferences", "top right"), -1);
        if(pos == -1 && strcmp(str, "top right") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "top center", 1, C_("preferences", "top center"), -1);
        if(pos == -1 && strcmp(str, "top center") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "bottom", 1, C_("preferences", "bottom"), -1);
        if(pos == -1 && strcmp(str, "bottom") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "hidden", 1, C_("preferences", "hidden"), -1);
        if(pos == -1 && strcmp(str, "hidden") == 0)
          pos = 4;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109655344), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109655344), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "bottom"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    gtk_widget_set_name(widget, "plugins/darkroom/image_infos_position");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109655344), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/ui/border_size");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("border around image in darkroom mode"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 0;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("plugins/darkroom/ui/border_size") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701109377280), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109377280), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(10 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("process the image in darkroom mode with a small border. set to 0 if you don't want any border."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/ui/border_size");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109377280), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/scrollbars");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show scrollbars for central view"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/scrollbars"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109374224), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109374224), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines whether scrollbars should be displayed"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/scrollbars");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109374224), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/demosaic/quality");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("demosaicing for zoomed out darkroom mode"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/demosaic/quality");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "always bilinear (fast)", 1, C_("preferences", "always bilinear (fast)"), -1);
        if(pos == -1 && strcmp(str, "always bilinear (fast)") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "at most RCD (reasonable)", 1, C_("preferences", "at most RCD (reasonable)"), -1);
        if(pos == -1 && strcmp(str, "at most RCD (reasonable)") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "full (possibly slow)", 1, C_("preferences", "full (possibly slow)"), -1);
        if(pos == -1 && strcmp(str, "full (possibly slow)") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109320496), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109320496), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "at most RCD (reasonable)"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("interpolation when not viewing 1:1 in darkroom mode: bilinear is fastest, but not as sharp. middle ground is using RCD + interpolation modes specified on the 'pixel interpolator' option (processing tab), full will use exactly the settings for full-size export. X-Trans sensors use VNG rather than RCD as middle ground."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/demosaic/quality");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109320496), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("preview_downsampling");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("reduce resolution of preview image"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("preview_downsampling");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "original", 1, C_("preferences", "original"), -1);
        if(pos == -1 && strcmp(str, "original") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "to 1/2", 1, C_("preferences", "to 1/2"), -1);
        if(pos == -1 && strcmp(str, "to 1/2") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "to 1/3", 1, C_("preferences", "to 1/3"), -1);
        if(pos == -1 && strcmp(str, "to 1/3") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "to 1/4", 1, C_("preferences", "to 1/4"), -1);
        if(pos == -1 && strcmp(str, "to 1/4") == 0)
          pos = 3;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109315504), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109315504), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "original"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("decrease to speed up preview rendering, may hinder accurate masking"), (gchar *)0);
    gtk_widget_set_name(widget, "preview_downsampling");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109315504), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/loading_screen");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show loading screen between images"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/loading_screen"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109310416), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109310416), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("show gray loading screen when navigating between images in the darkroom\ndisable to just show a toast message"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/loading_screen");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109310416), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("modules"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }
  
  {
    const gboolean is_default = dt_conf_is_default("channel_display");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("display of individual color channels"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("channel_display");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "false color", 1, C_("preferences", "false color"), -1);
        if(pos == -1 && strcmp(str, "false color") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "grayscale", 1, C_("preferences", "grayscale"), -1);
        if(pos == -1 && strcmp(str, "grayscale") == 0)
          pos = 1;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109662864), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109662864), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "false color"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines how color channels are displayed when activated in the parametric masks feature."), (gchar *)0);
    gtk_widget_set_name(widget, "channel_display");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109662864), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/hide_default_presets");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("hide built-in presets for processing modules"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/darkroom/hide_default_presets"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109641872), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109641872), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("hides built-in presets of processing modules in both presets and favourites menu."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/hide_default_presets");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109641872), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/show_guides_in_ui");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show the guides widget in modules UI"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/darkroom/show_guides_in_ui"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109638752), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109638752), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("show the guides widget in modules UI"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/show_guides_in_ui");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109638752), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/single_module");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("expand a single processing module at a time"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/single_module"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109421504), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109421504), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this option toggles the behavior of shift clicking in darkroom mode"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/single_module");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109421504), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/single_module_group_only");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("only collapse modules in current group"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/single_module_group_only"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109418400), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109418400), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if only expanding a single module at a time, only collapse other modules in the current group - ignore modules in other groups"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/single_module_group_only");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109418400), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/activate_expand");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("expand the module when it is activated, and collapse it when disabled"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/activate_expand"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109415248), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109415248), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this option allows to expand or collapse automatically the module when it is enabled or disabled."), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/activate_expand");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109415248), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/scroll_to_module");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("scroll processing modules to the top when expanded"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/scroll_to_module"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109383600), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109383600), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when this option is enabled then darktable will try to scroll the module to the top of the visible list"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/scroll_to_module");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109383600), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/temperature/colored_sliders");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("white balance slider colors"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/temperature/colored_sliders");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "no color", 1, C_("preferences", "no color"), -1);
        if(pos == -1 && strcmp(str, "no color") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "illuminant color", 1, C_("preferences", "illuminant color"), -1);
        if(pos == -1 && strcmp(str, "illuminant color") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "effect emulation", 1, C_("preferences", "effect emulation"), -1);
        if(pos == -1 && strcmp(str, "effect emulation") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701108952608), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108952608), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "no color"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("visual indication of temperature adjustments.\nin 'illuminant color' mode slider colors represent the color of the light source,\nin 'effect emulation' slider colors represent the effect the adjustment would have on the scene"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/temperature/colored_sliders");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108952608), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/colorbalance/layout");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("color balance slider block layout"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/colorbalance/layout");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "list", 1, C_("preferences", "list"), -1);
        if(pos == -1 && strcmp(str, "list") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "tabs", 1, C_("preferences", "tabs"), -1);
        if(pos == -1 && strcmp(str, "tabs") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "columns", 1, C_("preferences", "columns"), -1);
        if(pos == -1 && strcmp(str, "columns") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701108932144), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108932144), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "list"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("choose how to organise the slider blocks for lift, gamma and gain:\nlist - all sliders are shown in one long list (with headers),\ntabs - use tabs to switch between the blocks of sliders,\ncolumns - the blocks of sliders are shown next to each other (in narrow columns)"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/colorbalance/layout");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108932144), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/hide_header_buttons");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show right-side buttons in processing module headers"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("darkroom/ui/hide_header_buttons");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "always", 1, C_("preferences", "always"), -1);
        if(pos == -1 && strcmp(str, "always") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "active", 1, C_("preferences", "active"), -1);
        if(pos == -1 && strcmp(str, "active") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "dim", 1, C_("preferences", "dim"), -1);
        if(pos == -1 && strcmp(str, "dim") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "auto", 1, C_("preferences", "auto"), -1);
        if(pos == -1 && strcmp(str, "auto") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "fade", 1, C_("preferences", "fade"), -1);
        if(pos == -1 && strcmp(str, "fade") == 0)
          pos = 4;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "fit", 1, C_("preferences", "fit"), -1);
        if(pos == -1 && strcmp(str, "fit") == 0)
          pos = 5;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "smooth", 1, C_("preferences", "smooth"), -1);
        if(pos == -1 && strcmp(str, "smooth") == 0)
          pos = 6;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "glide", 1, C_("preferences", "glide"), -1);
        if(pos == -1 && strcmp(str, "glide") == 0)
          pos = 7;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701108927248), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108927248), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "always"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when the mouse is not over a module, the multi-instance, reset and preset buttons can be hidden:\nalways - always show all buttons,\nactive - only show the buttons when the mouse is over the module,\ndim - buttons are dimmed when mouse is away,\nauto - hide the buttons when the panel is narrow,\nfade - fade out all buttons when panel narrows,\nfit - hide all the buttons if the module name doesn't fit,\nsmooth - fade out all buttons in one header simultaneously,\nglide - gradually hide individual buttons as needed"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/hide_header_buttons");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108927248), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/show_mask_indicator");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show mask indicator in module headers"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/show_mask_indicator"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701108920080), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108920080), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if enabled, an icon will be shown in the header of any processing modules that have a mask applied"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/show_mask_indicator");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108920080), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/rename_new_instance");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prompt for name on addition of new instance"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/rename_new_instance"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701108916960), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108916960), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if enabled, a rename prompt will be present for each new module instance (either new instance or duplicate)"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/rename_new_instance");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108916960), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

static void
init_tab_processing (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("processing"), _("processing"));

    {
      GtkWidget *seclabel = gtk_label_new(_("image processing"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
    }
  
  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/export/force_lcms2");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("always use LittleCMS 2 to apply output color profile"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/export/force_lcms2"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109357264), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109357264), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this is slower than the default."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/export/force_lcms2");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109357264), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/export/pixel_interpolator_warp");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pixel interpolator (warp)"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/lighttable/export/pixel_interpolator_warp");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "bilinear", 1, C_("preferences", "bilinear"), -1);
        if(pos == -1 && strcmp(str, "bilinear") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "bicubic", 1, C_("preferences", "bicubic"), -1);
        if(pos == -1 && strcmp(str, "bicubic") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "lanczos2", 1, C_("preferences", "lanczos2"), -1);
        if(pos == -1 && strcmp(str, "lanczos2") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109307280), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109307280), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "bicubic"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("pixel interpolator used in modules for rotation, lens correction, liquify, cropping and final scaling (bilinear, bicubic, lanczos2)."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/export/pixel_interpolator_warp");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109307280), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/export/pixel_interpolator");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pixel interpolator (scaling)"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/lighttable/export/pixel_interpolator");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "bilinear", 1, C_("preferences", "bilinear"), -1);
        if(pos == -1 && strcmp(str, "bilinear") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "bicubic", 1, C_("preferences", "bicubic"), -1);
        if(pos == -1 && strcmp(str, "bicubic") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "lanczos2", 1, C_("preferences", "lanczos2"), -1);
        if(pos == -1 && strcmp(str, "lanczos2") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "lanczos3", 1, C_("preferences", "lanczos3"), -1);
        if(pos == -1 && strcmp(str, "lanczos3") == 0)
          pos = 3;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109302512), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109302512), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "lanczos3"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("pixel interpolator used for scaling (bilinear, bicubic, lanczos2, lanczos3)."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/export/pixel_interpolator");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109302512), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/lut3d/def_path");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("3D lut root folder"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_file_chooser_button_new(_("select directory"), GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_file_chooser_button_set_width_chars(GTK_FILE_CHOOSER_BUTTON(widget), 20);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/darkroom/lut3d/def_path");
    gtk_file_chooser_set_current_folder(GTK_FILE_CHOOSER(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "selection-changed", G_CALLBACK(preferences_changed_callback_idm139701109014560), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109014560), widget);
    gchar *default_path = dt_conf_expand_default_dir("$(home)");
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), default_path);
    g_free(default_path);
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
        gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this folder (and sub-folders) contains Lut files used by lut3d modules. (need a restart)."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/lut3d/def_path");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109014560), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/workflow");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("auto-apply pixel workflow defaults"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/workflow");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "scene-referred", 1, C_("preferences", "scene-referred"), -1);
        if(pos == -1 && strcmp(str, "scene-referred") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "display-referred", 1, C_("preferences", "display-referred"), -1);
        if(pos == -1 && strcmp(str, "display-referred") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "none", 1, C_("preferences", "none"), -1);
        if(pos == -1 && strcmp(str, "none") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109011216), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109011216), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "scene-referred"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("scene-referred workflow is based on linear modules and will auto-apply filmic and exposure,\ndisplay-referred workflow is based on Lab modules and will auto-apply base curve and the legacy module pipe order."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/workflow");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109011216), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/chromatic-adaptation");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("auto-apply chromatic adaptation defaults"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/chromatic-adaptation");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "modern", 1, C_("preferences", "modern"), -1);
        if(pos == -1 && strcmp(str, "modern") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "legacy", 1, C_("preferences", "legacy"), -1);
        if(pos == -1 && strcmp(str, "legacy") == 0)
          pos = 1;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109006384), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109006384), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "legacy"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("legacy performs a basic chromatic adaptation using only the white balance module\nmodern uses a combination of white balance module and color calibration module, with improved color science for chromatic adaptation"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/chromatic-adaptation");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109006384), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/basecurve/auto_apply_percamera_presets");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("auto-apply per camera basecurve presets"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/darkroom/basecurve/auto_apply_percamera_presets"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109001952), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109001952), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("use the per-camera basecurve by default instead of the generic manufacturer one if there is one available (needs a restart).\nthis option is taken into account when the \"auto-apply pixel workflow defaults\" is set to \"display-referred\".\nto prevent auto-apply basecurve presets \"auto-apply pixel workflow defaults\" should be set to \"none\""), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/basecurve/auto_apply_percamera_presets");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109001952), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/sharpen/auto_apply");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("auto-apply sharpen"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/darkroom/sharpen/auto_apply"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701108998288), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108998288), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this added sharpen is not recommended on cameras without a low-pass filter. you should disable this option if you use one of those more recent cameras or sharpen your images with other means."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/sharpen/auto_apply");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108998288), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ui/detect_mono_exif");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("detect monochrome previews"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ui/detect_mono_exif"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701108995088), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108995088), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("many monochrome images can be identified via EXIF and preview data. beware: this slows down imports and reading of EXIF data"), (gchar *)0);
    gtk_widget_set_name(widget, "ui/detect_mono_exif");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108995088), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/show_warnings");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("show warning messages"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/darkroom/show_warnings"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701108991952), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108991952), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("display messages in modules to warn beginner users when non-standard and possibly harmful settings are used in the pipeline.\nthese messages can be false-positive and should be disregarded if you know what you are doing. this option will hide them all the time."), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/show_warnings");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108991952), (gpointer)widget);

  }

    {
      GtkWidget *seclabel = gtk_label_new(_("cpu / gpu / memory"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
    }
  
  {
    const gboolean is_default = dt_conf_is_default("resourcelevel");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("darktable resources"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("resourcelevel");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "small", 1, C_("preferences", "small"), -1);
        if(pos == -1 && strcmp(str, "small") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "default", 1, C_("preferences", "default"), -1);
        if(pos == -1 && strcmp(str, "default") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "large", 1, C_("preferences", "large"), -1);
        if(pos == -1 && strcmp(str, "large") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "unrestricted", 1, C_("preferences", "unrestricted"), -1);
        if(pos == -1 && strcmp(str, "unrestricted") == 0)
          pos = 3;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110086160), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110086160), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "default"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);    
    /* xgettext:no-c-format */
    g_object_set(widget, "tooltip-text", _("defines how much darktable may take from your system resources.\n - default: darktable takes ~50% of your systems resources and gives darktable enough to be still performant.\n - small: should be used if you are simultaneously running applications taking large parts of your systems memory or opencl/gl applications like games or hugin.\n - large: is the best option if you are mainly using darktable and want it to take most of your systems resources for performance.\n - unrestricted: should only be used for developing extremely large images as darktable will take all of your systems resources and thus might lead to swapping and unexpected performance drops. use with caution and not recommended for general use!"), (gchar *)0);
    gtk_widget_set_name(widget, "resourcelevel");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110086160), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ui/performance");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prefer performance over quality"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ui/performance"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110080432), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110080432), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if switched on, thumbnails and previews are rendered at lower quality but 4 times faster"), (gchar *)0);
    gtk_widget_set_name(widget, "ui/performance");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110080432), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("cache_disk_backend");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("enable disk backend for thumbnail cache"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("cache_disk_backend"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110077328), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110077328), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if enabled, write thumbnails to disk (.cache/darktable/) when evicted from the memory cache. note that this can take a lot of memory (several gigabytes for 20k images) and will never delete cached thumbnails again. it's safe though to delete these manually, if you want. light table performance will be increased greatly when browsing a lot. to generate all thumbnails of your entire collection offline, run 'darktable-generate-cache'."), (gchar *)0);
    gtk_widget_set_name(widget, "cache_disk_backend");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110077328), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("cache_disk_backend_full");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("enable disk backend for full preview cache"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("cache_disk_backend_full"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110074336), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110074336), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if enabled, write full preview to disk (.cache/darktable/) when evicted from the memory cache. note that this can take a lot of memory (several gigabytes for 20k images) and will never delete cached thumbnails again. it's safe though to delete these manually, if you want. light table performance will be increased greatly when zooming image in full preview mode."), (gchar *)0);
    gtk_widget_set_name(widget, "cache_disk_backend_full");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110074336), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("opencl");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("activate OpenCL support"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("opencl"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110038624), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110038624), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if found, use OpenCL runtime on your system for improved processing speed. can be switched on and off at any time."), (gchar *)0);
    GtkWidget *notavailable = gtk_label_new(_("not available"));
    gtk_widget_set_halign(notavailable, GTK_ALIGN_START);
    gtk_widget_set_sensitive(notavailable, FALSE);
    g_object_set(notavailable, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_widget_set_sensitive(labelev, dt_capabilities_check("opencl"));
    gtk_widget_set_sensitive(widget, dt_capabilities_check("opencl"));
    if(!dt_capabilities_check("opencl"))
      g_object_set(labelev, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), dt_capabilities_check("opencl") ? box : notavailable, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110038624), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("opencl_scheduling_profile");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("OpenCL scheduling profile"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("opencl_scheduling_profile");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "default", 1, C_("preferences", "default"), -1);
        if(pos == -1 && strcmp(str, "default") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "multiple GPUs", 1, C_("preferences", "multiple GPUs"), -1);
        if(pos == -1 && strcmp(str, "multiple GPUs") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "very fast GPU", 1, C_("preferences", "very fast GPU"), -1);
        if(pos == -1 && strcmp(str, "very fast GPU") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110035248), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110035248), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "default"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines how preview and full pixelpipe tasks are scheduled on OpenCL enabled systems. default - GPU processes full and CPU processes preview pipe (adaptable by config parameters); multiple GPUs - process both pixelpipes in parallel on two different GPUs; very fast GPU - process both pixelpipes sequentially on the GPU."), (gchar *)0);
    GtkWidget *notavailable = gtk_label_new(_("not available"));
    gtk_widget_set_halign(notavailable, GTK_ALIGN_START);
    gtk_widget_set_sensitive(notavailable, FALSE);
    g_object_set(notavailable, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_widget_set_sensitive(labelev, dt_capabilities_check("opencl"));
    gtk_widget_set_sensitive(widget, dt_capabilities_check("opencl"));
    if(!dt_capabilities_check("opencl"))
      g_object_set(labelev, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), dt_capabilities_check("opencl") ? box : notavailable, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110035248), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("opencl_tuning_mode");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("tune OpenCL performance"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("opencl_tuning_mode");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "nothing", 1, C_("preferences", "nothing"), -1);
        if(pos == -1 && strcmp(str, "nothing") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "memory size", 1, C_("preferences", "memory size"), -1);
        if(pos == -1 && strcmp(str, "memory size") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "memory transfer", 1, C_("preferences", "memory transfer"), -1);
        if(pos == -1 && strcmp(str, "memory transfer") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "memory size and transfer", 1, C_("preferences", "memory size and transfer"), -1);
        if(pos == -1 && strcmp(str, "memory size and transfer") == 0)
          pos = 3;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110030032), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110030032), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "nothing"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("allows runtime tuning of OpenCL devices. 'memory size' uses a fixed 400MB headroom, 'memory transfer' tries a faster memory access mode (pinned memory) used for tiling."), (gchar *)0);
    GtkWidget *notavailable = gtk_label_new(_("not available"));
    gtk_widget_set_halign(notavailable, GTK_ALIGN_START);
    gtk_widget_set_sensitive(notavailable, FALSE);
    g_object_set(notavailable, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_widget_set_sensitive(labelev, dt_capabilities_check("opencl"));
    gtk_widget_set_sensitive(widget, dt_capabilities_check("opencl"));
    if(!dt_capabilities_check("opencl"))
      g_object_set(labelev, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), dt_capabilities_check("opencl") ? box : notavailable, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110030032), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

static void
init_tab_security (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("security"), _("security"));

    {
      GtkWidget *seclabel = gtk_label_new(_("general"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
    }
  
  {
    const gboolean is_default = dt_conf_is_default("ask_before_remove");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before removing images from the library"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ask_before_remove"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110017584), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110017584), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("always ask the user before removing image information from the library"), (gchar *)0);
    gtk_widget_set_name(widget, "ask_before_remove");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110017584), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ask_before_delete");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before deleting images from disk"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ask_before_delete"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110014496), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110014496), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("always ask the user before any image file is deleted"), (gchar *)0);
    gtk_widget_set_name(widget, "ask_before_delete");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110014496), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ask_before_discard");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before discarding history stack"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ask_before_discard"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110011440), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110011440), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("always ask the user before history stack is discarded on any image"), (gchar *)0);
    gtk_widget_set_name(widget, "ask_before_discard");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110011440), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("send_to_trash");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("try to use trash when deleting images"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("send_to_trash"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110008368), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110008368), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("send files to trash instead of permanently deleting files on system that supports it"), (gchar *)0);
    gtk_widget_set_name(widget, "send_to_trash");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110008368), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ask_before_move");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before moving images from film roll folder"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ask_before_move"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110005280), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110005280), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("always ask the user before any image file is moved."), (gchar *)0);
    gtk_widget_set_name(widget, "ask_before_move");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110005280), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ask_before_copy");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before copying images to new film roll folder"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ask_before_copy"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110002208), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110002208), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("always ask the user before any image file is copied."), (gchar *)0);
    gtk_widget_set_name(widget, "ask_before_copy");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110002208), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ask_before_rmdir");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before removing empty folders"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("ask_before_rmdir"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109999136), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109999136), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("always ask the user before removing any empty folder. this can happen after moving or deleting images."), (gchar *)0);
    gtk_widget_set_name(widget, "ask_before_rmdir");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109999136), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/tagging/ask_before_delete_tag");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before deleting a tag"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/tagging/ask_before_delete_tag"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109509696), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109509696), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    gtk_widget_set_name(widget, "plugins/lighttable/tagging/ask_before_delete_tag");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109509696), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/style/ask_before_delete_style");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before deleting a style"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/style/ask_before_delete_style"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109464080), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109464080), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    gtk_widget_set_name(widget, "plugins/lighttable/style/ask_before_delete_style");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109464080), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/preset/ask_before_delete_preset");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before deleting a preset"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/preset/ask_before_delete_preset"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109461184), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109461184), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("will ask for confirmation before deleting or overwriting a preset"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/preset/ask_before_delete_preset");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109461184), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/export/ask_before_export_overwrite");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("ask before exporting in overwrite mode"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/export/ask_before_export_overwrite"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109458080), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109458080), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("will ask for confirmation before exporting files in overwrite mode"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/export/ask_before_export_overwrite");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109458080), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("other"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }
  
  {
    const gboolean is_default = dt_conf_is_default("plugins/pwstorage/pwstorage_backend");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("password storage backend to use"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/pwstorage/pwstorage_backend");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "auto", 1, C_("preferences", "auto"), -1);
        if(pos == -1 && strcmp(str, "auto") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "none", 1, C_("preferences", "none"), -1);
        if(pos == -1 && strcmp(str, "none") == 0)
          pos = 1;
      if(dt_capabilities_check("libsecret")) {
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "libsecret", 1, C_("preferences", "libsecret"), -1);
        if(pos == -1 && strcmp(str, "libsecret") == 0)
          pos = 2;
      }
          if(dt_capabilities_check("kwallet")) {
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "kwallet", 1, C_("preferences", "kwallet"), -1);
        if(pos == -1 && strcmp(str, "kwallet") == 0)
          pos = 3;
      }
          

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109200640), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109200640), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "auto"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("the storage backend for password storage: auto, none, libsecret, kwallet"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/pwstorage/pwstorage_backend");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109200640), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/audio_player");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("executable for playing audio files"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_entry_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/lighttable/audio_player");
    gtk_entry_set_text(GTK_ENTRY(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109017680), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109017680), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "aplay");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this external program is used to play audio files some cameras record to keep notes for images"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/audio_player");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109017680), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

static void
init_tab_storage (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("storage"), _("storage"));

   {
      GtkWidget *seclabel = gtk_label_new(_("database"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }

  {
    const gboolean is_default = dt_conf_is_default("database/maintenance_check");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("check for database maintenance"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("database/maintenance_check");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "never", 1, C_("preferences", "never"), -1);
        if(pos == -1 && strcmp(str, "never") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on startup", 1, C_("preferences", "on startup"), -1);
        if(pos == -1 && strcmp(str, "on startup") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on close", 1, C_("preferences", "on close"), -1);
        if(pos == -1 && strcmp(str, "on close") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on both", 1, C_("preferences", "on both"), -1);
        if(pos == -1 && strcmp(str, "on both") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on startup (don't ask)", 1, C_("preferences", "on startup (don't ask)"), -1);
        if(pos == -1 && strcmp(str, "on startup (don't ask)") == 0)
          pos = 4;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on close (don't ask)", 1, C_("preferences", "on close (don't ask)"), -1);
        if(pos == -1 && strcmp(str, "on close (don't ask)") == 0)
          pos = 5;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on both (don't ask)", 1, C_("preferences", "on both (don't ask)"), -1);
        if(pos == -1 && strcmp(str, "on both (don't ask)") == 0)
          pos = 6;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110146288), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110146288), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "on close"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this option indicates when to check database fragmentation and perform maintenance"), (gchar *)0);
    gtk_widget_set_name(widget, "database/maintenance_check");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110146288), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("database/maintenance_freepage_ratio");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("database fragmentation ratio threshold"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 0;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("database/maintenance_freepage_ratio") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701110112560), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110112560), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(25 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("fragmentation ratio above which to ask or carry out automatically database maintenance"), (gchar *)0);
    gtk_widget_set_name(widget, "database/maintenance_freepage_ratio");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110112560), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("database/create_snapshot");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("create database snapshot"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("database/create_snapshot");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "never", 1, C_("preferences", "never"), -1);
        if(pos == -1 && strcmp(str, "never") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "once a month", 1, C_("preferences", "once a month"), -1);
        if(pos == -1 && strcmp(str, "once a month") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "once a week", 1, C_("preferences", "once a week"), -1);
        if(pos == -1 && strcmp(str, "once a week") == 0)
          pos = 2;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "once a day", 1, C_("preferences", "once a day"), -1);
        if(pos == -1 && strcmp(str, "once a day") == 0)
          pos = 3;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on close", 1, C_("preferences", "on close"), -1);
        if(pos == -1 && strcmp(str, "on close") == 0)
          pos = 4;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110109616), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110109616), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "once a week"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("database snapshots are created right before closing darktable. options allow you to choose how often to make snapshots:\nnever - simply don't do snapshots. that way the only snapshots done are mandatory version-upgrade snapshots\nonce a month - create snapshot if a month has passed since last snapshot\nonce a week - create snapshot if 7 days had passed since last snapshot\nonce a day - create snapshot if over 24h passed since last snapshot\non close - create snapshot every time darktable is closed"), (gchar *)0);
    gtk_widget_set_name(widget, "database/create_snapshot");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110109616), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("database/keep_snapshots");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("how many snapshots to keep"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 0;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("database/keep_snapshots") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701110104176), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110104176), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(10 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("after successfully creating snapshot, how many older snapshots to keep (excluding mandatory version update ones). enter -1 to keep all snapshots\nkeep in mind that snapshots do take some space and you only need the most recent one for successful restore"), (gchar *)0);
    gtk_widget_set_name(widget, "database/keep_snapshots");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110104176), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("xmp"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }

  {
    const gboolean is_default = dt_conf_is_default("write_sidecar_files");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("write sidecar file for each image"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("write_sidecar_files");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "never", 1, C_("preferences", "never"), -1);
        if(pos == -1 && strcmp(str, "never") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "after edit", 1, C_("preferences", "after edit"), -1);
        if(pos == -1 && strcmp(str, "after edit") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "on import", 1, C_("preferences", "on import"), -1);
        if(pos == -1 && strcmp(str, "on import") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110057856), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110057856), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "on import"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("the sidecar files hold information about all your development steps to allow flawless re-importing of image files.\n\ndepending on the selected mode sidecar files will be written:\n - never\n - on import: immediately after importing the image\n - after edit: after any user change on the image"), (gchar *)0);
    gtk_widget_set_name(widget, "write_sidecar_files");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110057856), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("compress_xmp_tags");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("store xmp tags in compressed format"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("compress_xmp_tags");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "never", 1, C_("preferences", "never"), -1);
        if(pos == -1 && strcmp(str, "never") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "always", 1, C_("preferences", "always"), -1);
        if(pos == -1 && strcmp(str, "always") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "only large entries", 1, C_("preferences", "only large entries"), -1);
        if(pos == -1 && strcmp(str, "only large entries") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110052992), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110052992), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "only large entries"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("entries in xmp tags can get rather large and may exceed the available space to store the history stack in output files. this option allows xmp tags to be compressed and save space."), (gchar *)0);
    gtk_widget_set_name(widget, "compress_xmp_tags");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110052992), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("run_crawler_on_start");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("look for updated xmp files on startup"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("run_crawler_on_start"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109020752), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109020752), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("check file modification times of all xmp files on startup to check if any got updated in the meantime"), (gchar *)0);
    gtk_widget_set_name(widget, "run_crawler_on_start");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109020752), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

static void
init_tab_misc (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("miscellaneous"), _("miscellaneous"));

   {
      GtkWidget *seclabel = gtk_label_new(_("interface"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }

  {
    const gboolean is_default = dt_conf_is_default("accel/load_defaults");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("load default shortcuts at startup"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("accel/load_defaults"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110159264), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110159264), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("load default shortcuts before user settings. switch off to prevent deleted defaults returning"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/load_defaults");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110159264), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("bauhaus/zoom_step");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("scale slider step with min/max"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("bauhaus/zoom_step"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110153712), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110153712), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("vary bauhaus slider step size with min/max range"), (gchar *)0);
    gtk_widget_set_name(widget, "bauhaus/zoom_step");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110153712), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("modules/default_presets_first");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("sort built-in presets first"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("modules/default_presets_first"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109644976), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109644976), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("whether to show built-in presets first before user's presets in presets menu."), (gchar *)0);
    gtk_widget_set_name(widget, "modules/default_presets_first");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109644976), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("darkroom/ui/sidebar_scroll_default");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("mouse wheel scrolls modules side panel by default"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("darkroom/ui/sidebar_scroll_default"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109380464), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109380464), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when enabled, use mouse wheel to scroll modules side panel.  use ctrl+alt to use mouse wheel for data entry.  when disabled, this behavior is reversed"), (gchar *)0);
    gtk_widget_set_name(widget, "darkroom/ui/sidebar_scroll_default");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109380464), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("panel_scrollbars_always_visible");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("always show panels' scrollbars"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("panel_scrollbars_always_visible"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109371168), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109371168), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("defines whether the panel scrollbars should be always visible or activated only depending on the content.  (need a restart)"), (gchar *)0);
    gtk_widget_set_name(widget, "panel_scrollbars_always_visible");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109371168), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/darkroom/histogram/panel_position");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("position of the scopes module"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/darkroom/histogram/panel_position");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "left", 1, C_("preferences", "left"), -1);
        if(pos == -1 && strcmp(str, "left") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "right", 1, C_("preferences", "right"), -1);
        if(pos == -1 && strcmp(str, "right") == 0)
          pos = 1;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109119168), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109119168), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "right"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("position the scopes at the top-left or top-right of the screen"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/darkroom/histogram/panel_position");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109119168), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("ui_last/display_profile_source");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("method to use for getting the display profile"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("ui_last/display_profile_source");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "all", 1, C_("preferences", "all"), -1);
        if(pos == -1 && strcmp(str, "all") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "xatom", 1, C_("preferences", "xatom"), -1);
        if(pos == -1 && strcmp(str, "xatom") == 0)
          pos = 1;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "colord", 1, C_("preferences", "colord"), -1);
        if(pos == -1 && strcmp(str, "colord") == 0)
          pos = 2;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109028240), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109028240), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "all"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("this option allows to force a specific means of getting the current display profile. this is useful when one alternative gives wrong results"), (gchar *)0);
    gtk_widget_set_name(widget, "ui_last/display_profile_source");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109028240), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/midi/devices");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("order or exclude midi devices"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_entry_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("plugins/midi/devices");
    gtk_entry_set_text(GTK_ENTRY(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701108844128), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701108844128), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("comma-separated list of device name fragments that if matched load midi device at id given by location in list or if preceded by - prevent matching devices from loading. add encoding and number of knobs like 'BeatStep:63:16'"), (gchar *)0);
    GtkWidget *notavailable = gtk_label_new(_("not available"));
    gtk_widget_set_halign(notavailable, GTK_ALIGN_START);
    gtk_widget_set_sensitive(notavailable, FALSE);
    g_object_set(notavailable, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_widget_set_sensitive(labelev, dt_capabilities_check("midi"));
    gtk_widget_set_sensitive(widget, dt_capabilities_check("midi"));
    if(!dt_capabilities_check("midi"))
      g_object_set(labelev, "tooltip-text", _("not available on this system"), (gchar *)0);
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), dt_capabilities_check("midi") ? box : notavailable, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701108844128), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("tags"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }

  {
    const gboolean is_default = dt_conf_is_default("omit_tag_hierarchy");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("omit hierarchy in simple tag lists"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("omit_tag_hierarchy"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110048432), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110048432), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when creating XMP file the hierarchical tags are also added as a simple list of non-hierarchical ones to make them visible to some other programs. when this option is checked darktable will only include their last part and ignore the rest. so 'foo|bar|baz' will only add 'baz'."), (gchar *)0);
    gtk_widget_set_name(widget, "omit_tag_hierarchy");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110048432), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("shortcuts with multiple instances"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
      g_object_set(lbox,  "tooltip-text", _("where multiple module instances are present, these preferences control rules that are applied (in order) to decide which module instance shortcuts will be applied to"), (gchar *)0);
   }

  {
    const gboolean is_default = dt_conf_is_default("accel/prefer_focused");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prefer focused instance"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("accel/prefer_focused"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110183952), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110183952), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if an instance of the module has focus, apply shortcut to that instance\nnote: blending shortcuts always apply to the focused instance"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/prefer_focused");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110183952), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("accel/prefer_expanded");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prefer expanded instances"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("accel/prefer_expanded"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110180832), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110180832), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("if instances of the module are expanded, ignore collapsed instances"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/prefer_expanded");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110180832), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("accel/prefer_enabled");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prefer enabled instances"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("accel/prefer_enabled"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110177616), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110177616), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("after applying the above rule, if instances of the module are active, ignore inactive instances"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/prefer_enabled");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110177616), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("accel/prefer_unmasked");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prefer unmasked instances"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("accel/prefer_unmasked"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110174512), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110174512), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("after applying the above rules, if instances of the module are unmasked, ignore masked instances"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/prefer_unmasked");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110174512), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("accel/select_order");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("selection order"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("accel/select_order");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "first instance", 1, C_("preferences", "first instance"), -1);
        if(pos == -1 && strcmp(str, "first instance") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "last instance", 1, C_("preferences", "last instance"), -1);
        if(pos == -1 && strcmp(str, "last instance") == 0)
          pos = 1;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110171408), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110171408), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "last instance"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("after applying the above rules, apply the shortcut based on its position in the pixelpipe"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/select_order");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110171408), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("accel/assign_instance");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("allow visual assignment to specific instances"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("accel/assign_instance"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110167040), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110167040), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("when multiple instances are present on an image this allows shortcuts to be visually assigned to those specific instances\notherwise shortcuts will always be assigned to the preferred instance"), (gchar *)0);
    gtk_widget_set_name(widget, "accel/assign_instance");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110167040), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("map / geolocalization view"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }
  
  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/metadata_view/pretty_location");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("pretty print the image location"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/metadata_view/pretty_location"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109430320), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109430320), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("show a more readable representation of the location in the image information module"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/metadata_view/pretty_location");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109430320), (gpointer)widget);

  }

   {
      GtkWidget *seclabel = gtk_label_new(_("slideshow view"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }

  {
    const gboolean is_default = dt_conf_is_default("slideshow_delay");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("waiting time between each picture in slideshow"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 0;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("slideshow_delay") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701110091200), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110091200), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(5 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    gtk_widget_set_name(widget, "slideshow_delay");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110091200), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

static void
init_tab_import (GtkWidget *dialog, GtkWidget *stack)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *scroll = gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scroll), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  viewport = gtk_viewport_new(NULL, NULL);
  gtk_viewport_set_shadow_type(GTK_VIEWPORT(viewport), GTK_SHADOW_NONE); // doesn't seem to work from gtkrc
  gtk_container_add(GTK_CONTAINER(scroll), viewport);
  gtk_container_add(GTK_CONTAINER(viewport), grid);
  gtk_stack_add_titled(GTK_STACK(stack), scroll, _("import"), _("import"));

   {
      GtkWidget *seclabel = gtk_label_new(_("session options"));
      GtkWidget *lbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
      gtk_box_pack_start(GTK_BOX(lbox), seclabel, FALSE, FALSE, 0);
      gtk_widget_set_name(lbox, "pref_section");
      gtk_grid_attach(GTK_GRID(grid), lbox, 0, line++, 2, 1);
   }

  {
    const gboolean is_default = dt_conf_is_default("session/base_directory_pattern");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("base directory naming pattern"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_entry_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("session/base_directory_pattern");
    gtk_entry_set_text(GTK_ENTRY(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109632592), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109632592), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "$(PICTURES_FOLDER)/Darktable");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("part of full import path for an import session"), (gchar *)0);
    gtk_widget_set_name(widget, "session/base_directory_pattern");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109632592), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("session/sub_directory_pattern");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("sub directory naming pattern"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_entry_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("session/sub_directory_pattern");
    gtk_entry_set_text(GTK_ENTRY(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109629504), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109629504), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "$(YEAR)$(MONTH)$(DAY)_$(JOBCODE)");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("part of full import path for an import session"), (gchar *)0);
    gtk_widget_set_name(widget, "session/sub_directory_pattern");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109629504), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("session/use_filename");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("keep original filename"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("session/use_filename"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109626416), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109626416), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("keep original filename instead of a pattern while importing from camera or card"), (gchar *)0);
    gtk_widget_set_name(widget, "session/use_filename");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109626416), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("session/filename_pattern");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("file naming pattern"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_entry_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, TRUE, TRUE, 0);
    gtk_widget_set_halign(widget, GTK_ALIGN_FILL);
    gtk_widget_set_hexpand(widget, TRUE);
    gchar *setting = dt_conf_get_string("session/filename_pattern");
    gtk_entry_set_text(GTK_ENTRY(widget), setting);
    g_free(setting);
    g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109623344), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109623344), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), "$(YEAR)$(MONTH)$(DAY)_$(SEQUENCE).$(FILE_EXTENSION)");
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("file naming pattern used for a import session"), (gchar *)0);
    gtk_widget_set_name(widget, "session/filename_pattern");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109623344), (gpointer)widget);

  }

  gtk_widget_show_all(stack);
}

GtkWidget *dt_prefs_init_dialog_collect(GtkWidget *dialog)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  g_object_set_data(G_OBJECT(dialog), "local-dialog", GUINT_TO_POINTER(1));

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/tagging/no_uncategorized");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("do not set the 'uncategorized' entry for tags"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/tagging/no_uncategorized"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701110045440), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110045440), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("do not set the 'uncategorized' entry for tags which do not have children"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/tagging/no_uncategorized");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110045440), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/tagging/case_sensitivity");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("tags case sensitivity"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/lighttable/tagging/case_sensitivity");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "sensitive", 1, C_("preferences", "sensitive"), -1);
        if(pos == -1 && strcmp(str, "sensitive") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "insensitive", 1, C_("preferences", "insensitive"), -1);
        if(pos == -1 && strcmp(str, "insensitive") == 0)
          pos = 1;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701110042672), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701110042672), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "insensitive"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("tags case sensitivity. without the Sqlite ICU extension, insensitivity works only for the 26 latin letters"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/tagging/case_sensitivity");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701110042672), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/collect/history_max");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("number of collections to be stored"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 1;
    max = 50;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("plugins/lighttable/collect/history_max") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701109989824), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109989824), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(10 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("the number of recent collections to store and show in this list"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/collect/history_max");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109989824), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/collect/history_hide");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("hide the history button and show a specific module instead"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/collect/history_hide"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109986592), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109986592), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "FALSE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("hide the history button and show the recent collections module instead"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/collect/history_hide");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109986592), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("show_folder_levels");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("number of folder levels to show in lists"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 1;
    max = 5;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("show_folder_levels") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701109937104), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109937104), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(1 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("the number of folder levels to show in film roll names, starting from the right"), (gchar *)0);
    gtk_widget_set_name(widget, "show_folder_levels");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109937104), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/collect/filmroll_sort");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("sort film rolls by"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    GtkTreeIter iter;
    GtkListStore *store = gtk_list_store_new(2, G_TYPE_STRING, G_TYPE_STRING);
    gchar *str = dt_conf_get_string("plugins/collect/filmroll_sort");
    gint pos = -1;

        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "id", 1, C_("preferences", "id"), -1);
        if(pos == -1 && strcmp(str, "id") == 0)
          pos = 0;
      
        gtk_list_store_append(store, &iter);
        gtk_list_store_set(store, &iter, 0, "folder", 1, C_("preferences", "folder"), -1);
        if(pos == -1 && strcmp(str, "folder") == 0)
          pos = 1;
      

    g_free(str);

    widget = gtk_combo_box_new_with_model(GTK_TREE_MODEL(store));
    gtk_widget_set_hexpand(widget, FALSE);
    g_object_unref(store);
    GtkCellRenderer *renderer = gtk_cell_renderer_text_new();
    gtk_cell_renderer_set_padding(renderer, 0, 0);
    gtk_cell_layout_pack_start(GTK_CELL_LAYOUT(widget), renderer, TRUE);
    gtk_cell_layout_set_attributes(GTK_CELL_LAYOUT(widget), renderer, "text", 1, NULL);
    gtk_combo_box_set_active(GTK_COMBO_BOX(widget), pos);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
     g_signal_connect(G_OBJECT(widget), "changed", G_CALLBACK(preferences_changed_callback_idm139701109903088), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109903088), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "id"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("sets the collections-list order for film rolls"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/collect/filmroll_sort");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109903088), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/collect/descending");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("sort collection descending"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/collect/descending"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109899184), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109899184), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("sort the following collections in descending order: 'film roll' by folder, 'folder', 'times' (e.g. 'capture date')"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/collect/descending");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109899184), (gpointer)widget);

  }

  gtk_box_pack_start(GTK_BOX(area), grid, FALSE, FALSE, 0);
  return grid;
  }

GtkWidget *dt_prefs_init_dialog_recentcollect(GtkWidget *dialog)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  g_object_set_data(G_OBJECT(dialog), "local-dialog", GUINT_TO_POINTER(1));

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/recentcollect/max_items");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("number of collections to be stored"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 1;
    max = 50;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("plugins/lighttable/recentcollect/max_items") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701109996032), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109996032), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(10 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("the number of recent collections to store and show in this list"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/recentcollect/max_items");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109996032), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/recentcollect/hide");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("prefer a history button in the collections module"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    widget = gtk_check_button_new();
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(widget), dt_conf_get_bool("plugins/lighttable/recentcollect/hide"));
    g_signal_connect(G_OBJECT(widget), "toggled", G_CALLBACK(preferences_changed_callback_idm139701109992688), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109992688), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%s'"), C_("preferences", "TRUE"));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("hide this module and instead access collections history with a button in the collections module"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/recentcollect/hide");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109992688), (gpointer)widget);

  }

  gtk_box_pack_start(GTK_BOX(area), grid, FALSE, FALSE, 0);
  return grid;
  }

GtkWidget *dt_prefs_init_dialog_import(GtkWidget *dialog)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  g_object_set_data(G_OBJECT(dialog), "local-dialog", GUINT_TO_POINTER(1));

  gtk_box_pack_start(GTK_BOX(area), grid, FALSE, FALSE, 0);
  return grid;
  }

GtkWidget *dt_prefs_init_dialog_tagging(GtkWidget *dialog)
{
  GtkWidget *widget, *label, *labelev, *viewport, *box;
  GtkWidget *grid = gtk_grid_new();
  gtk_grid_set_row_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(3));
  gtk_grid_set_column_spacing(GTK_GRID(grid), DT_PIXEL_APPLY_DPI(5));
  gtk_widget_set_valign(grid, GTK_ALIGN_START);
  int line = 0;
  char tooltip[1024];
  GtkWidget *area = gtk_dialog_get_content_area(GTK_DIALOG(dialog));
  g_object_set_data(G_OBJECT(dialog), "local-dialog", GUINT_TO_POINTER(1));

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/tagging/confidence");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("suggested tags level of confidence"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = 0;
    max = 100;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("plugins/lighttable/tagging/confidence") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701109490064), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109490064), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(50 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);    
    /* xgettext:no-c-format */
    g_object_set(widget, "tooltip-text", _("level of confidence to include the tag in the suggestions list, 0: all associated tags, 99: 99% matching associated tags, 100: no matching tag to show only recent tags (faster)"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/tagging/confidence");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109490064), (gpointer)widget);

  }

  {
    const gboolean is_default = dt_conf_is_default("plugins/lighttable/tagging/nb_recent_tags");
    GtkWidget *labdef;
    if(is_default)
    {
       labdef = gtk_label_new("");
    }
    else
    {
       labdef = gtk_label_new(NON_DEF_CHAR);
       g_object_set(labdef, "tooltip-text", _("this setting has been modified"), (gchar *)0);
    }
    gtk_widget_set_name(labdef, "preference_non_default");
    label = gtk_label_new(_("number of recently attached tags"));
    gtk_widget_set_halign(label, GTK_ALIGN_START);
    labelev = gtk_event_box_new();
    gtk_widget_add_events(labelev, GDK_BUTTON_PRESS_MASK);
    gtk_container_add(GTK_CONTAINER(labelev), label);
    gint min = G_MININT;
    gint max = G_MAXINT;
    min = -1;
    max = 1000;
    float factor = 1.0f;
    double tmp;
    tmp = min * (double)factor; min = tmp;
    tmp = max * (double)factor; max = tmp;
    widget = gtk_spin_button_new_with_range(min, max, 1);
    box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 0);
    gtk_box_pack_start(GTK_BOX(box), widget, FALSE, FALSE, 0);
    gtk_widget_set_hexpand(widget, FALSE);
    gtk_spin_button_set_digits(GTK_SPIN_BUTTON(widget), 0);
    gtk_spin_button_set_value(GTK_SPIN_BUTTON(widget), dt_conf_get_int("plugins/lighttable/tagging/nb_recent_tags") * factor);
    g_signal_connect(G_OBJECT(widget), "value-changed", G_CALLBACK(preferences_changed_callback_idm139701109486912), labdef);
    g_signal_connect(G_OBJECT(dialog), "response", G_CALLBACK(preferences_response_callback_idm139701109486912), widget);
    snprintf(tooltip, 1024, _("double click to reset to `%d'"), (int)(20 * factor));
    g_object_set(labelev,  "tooltip-text", tooltip, (gchar *)0);
    gtk_event_box_set_visible_window(GTK_EVENT_BOX(labelev), FALSE);
    g_object_set(widget, "tooltip-text", _("number of recently attached tags which are included in the suggestions list. the value `-1' disables the recent list"), (gchar *)0);
    gtk_widget_set_name(widget, "plugins/lighttable/tagging/nb_recent_tags");
    gtk_grid_attach(GTK_GRID(grid), labelev, 0, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), labdef, 1, line, 1, 1);
    gtk_grid_attach(GTK_GRID(grid), box, 2, line++, 1, 1);
    g_signal_connect(G_OBJECT(labelev), "button-press-event", G_CALLBACK(reset_widget_idm139701109486912), (gpointer)widget);

  }

  gtk_box_pack_start(GTK_BOX(area), grid, FALSE, FALSE, 0);
  return grid;
  }

#endif
